"use strict";
/**
 * lerna-utils
 * Internal utilities for interacting with a lerna monorepo
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.packagePackageJsons = exports.lernaPackages = exports.prettyStringifyJson = exports.trace = exports.writeFile = exports.readFile = void 0;
const path = __importStar(require("path"));
const fs = __importStar(require("fs"));
const t = __importStar(require("io-ts"));
const A = __importStar(require("fp-ts/Array"));
const E = __importStar(require("fp-ts/Either"));
const F = __importStar(require("fluture"));
const execa_1 = __importDefault(require("execa"));
const function_1 = require("fp-ts/lib/function");
const LernaPackage_1 = require("@typescript-tools/io-ts/dist/lib/LernaPackage");
const StringifiedJSON_1 = require("@typescript-tools/io-ts/dist/lib/StringifiedJSON");
const readFile = (file) => F.node(done => fs.readFile(file, 'utf8', done));
exports.readFile = readFile;
const writeFile = (file) => (contents) => F.node(done => fs.writeFile(file, contents, done));
exports.writeFile = writeFile;
// TODO: pull into its own external package
/* eslint-disable @typescript-eslint/no-explicit-any */
function trace(logger, ...tag) {
    return function trace(value) {
        if (tag.length > 0) {
            logger(...tag, value);
        }
        else {
            logger(value);
        }
        return value;
    };
}
exports.trace = trace;
// TODO: pull into its own package
function prettyStringifyJson(u, onError) {
    return E.tryCatch(() => JSON.stringify(u, null, 4) + '\n', onError);
}
exports.prettyStringifyJson = prettyStringifyJson;
// TODO: pull into its own package
/**
 * Get list of all lerna packages from `lerna list --all`.
 */
function lernaPackages(root) {
    return F.Future((reject, resolve) => {
        const subcommand = execa_1.default.command('npx lerna list --all --json', { cwd: root });
        subcommand
            .then(({ stdout }) => function_1.pipe(stdout, StringifiedJSON_1.StringifiedJSON(t.array(LernaPackage_1.LernaPackage)).decode.bind(null), E.fold(reject, resolve)))
            .catch(reject);
        return function onCancel() {
            subcommand.cancel();
        };
    });
}
exports.lernaPackages = lernaPackages;
// TODO: pull into its own package
function packagePackageJsons(root) {
    return lernaPackages(root)
        .pipe(F.chain(function_1.flow(A.map(pkg => exports.readFile(path.resolve(pkg.location, 'package.json'))
        .pipe(F.chain(contents => function_1.pipe(E.parseJSON(contents, E.toError), E.map(contents => F.resolve({ pkg, contents })), E.getOrElseW(error => F.reject(`Unable to parse ${pkg.location}/package.json, ${error.message}`)))))), F.parallel(200))));
}
exports.packagePackageJsons = packagePackageJsons;
//# sourceMappingURL=lerna-utils.js.map